#!/usr/local/bin/awk -f

# "Auto" is if you plan to automatically inject the template into the article and AWB F10 mode

# Demon to pass data back and forth between Windows host and Linux guest OS under VirtualBox
# See also demon-win.awk for the version running on the Windows host.
# Purposes is to run AWB on windows, and unix scripts on Linux. 

# CAUTION: NOT CONVERTED TO PROJECT[] SYSTEM

@include "init.awk"
@include "library.awk"

BEGIN {

  main()

}

function main(    name,tempid,article) {

  removefile(Ramdisk "article.txt")              # Clear out old files
  removefile(Ramdisk "abort.txt")              

  prnt("\ndemon-lin.awk: Waiting for " Ramdisk "name.txt ...")

  while(1) {

    sleep(2)
    Z++
    if(Z > 500) exit   # time-out. 2500 = about 90 minutes w/ 2sec sleep

    if( exists(Ramdisk "name.txt") ) {

      Z = 0             # reset time-out

      name = strip( readfile(Ramdisk "name.txt") )
      prnt("demon-lin.awk: New job request: " name )
      removefile(Ramdisk "name.txt")
      removefile(Ramdisk "article.txt")

      if(length(name) > 0) {           
#        if( nameisinfile(name, "ia9out-manual") || nameisinfile(name, "ia9out-search") || nameisaz(name) ) {
        if( 0 ) {
          abort("demon-lin.awk: Status skipping. " name)
        }
        else {
          tempid = whatistempid(name, "ia9out-index")
          if(tempid == "" || tempid == 0) {
            abort("demon-lin.awk: Error unknown tempid. " name)
          }
          else {
            article = http2var("https://en.wikipedia.org/w/index.php?title=" gensub(" ","_","g",name) "&action=raw")
            if(length(article) == 0) {
              abort("demon-lin.awk: Error unable to retrieve wikipedia wikisource. " name)
            }
            else {

              sys2var(MV " " tempid "article.txt " tempid "article.txt.demon-lin")
              print article > tempid "article.txt"
              close(tempid "article.txt")

              if(! exists(tempid "choose.txt") ) {
                abort("demon-lin.awk: Error choose.txt not found. " name)
              }
              else {                                                   # Get template from choose.txt

                j = i = c = 0
                choose = readfile(tempid "choose.txt")
                c = split(choose, a, "\n")
                while(i++ < c) {
                  safe = strip(a[i])
                  if(safe ~ /Internet Archive author/) {
                    if(substr(safe,length(safe) - 2, length(safe)) ~ / [*]$/) {
                      j++
                      match(safe, /{{Internet Archive author[^}]*}}/, k)
                      Found[j] = k[0]
                    }
                  }
                }
                if(j != 1) {
                  sendto("ia9out-manual", name, "choosetxt")
                  abort("demon-lin.awk: Error choose.txt has < or > 1 recommendations. Sent to manual. " name)
                }
                if(j == 1) {                                          # Find template(s) in article.txt
                  j = i = c = 0
                  article = readfile(tempid "article.txt")
                  c = split(article, a, "\n")
                  while(i++ < c) {
                    safe = strip(a[i])
                    if( match(safe, /{{Internet Archive author[^}]*}}/,k) ) {
                      j++
                      Found2[j] = k[0]
                    }
                  }
                  if(j != 1) {
                    sendto("ia9out-manual", name, "articletxt")
                    abort("demon-lin.awk: Status article.txt has < or > 1 templates. Sent to manual. " name)
                  }
                  if(j == 1) {
                    if( Found2[1] ~ /[|][ ]{0,1}name[=]|[|][ ]{0,1}dname[=]|[|][ ]{0,1}coda[=]/ ) {    
                      sendto("ia9out-manual", name, "articletxt")
                      abort("demon-lin.awk: Status article.txt has name|dname|coda in template. Sent to manual. " name)
                    }
                    else {
                      if( strip(tolower(Found2[1])) == strip(tolower(Found[1])) ) {
                        abort("demon-lin.awk: Status no change in template detected. " name)
                      }
                      else {
                        command = SED " 's/" Found2[1] "/" Found[1] "/g' " tempid "article.txt > " tempid "article.txt.final"
                        sys2var(command)
                        if(exists(tempid "article.txt.final") ){
                          command = CP " " tempid "article.txt.final " Ramdisk "article.txt"
                          prnt("demon-lin.awk: Status successful. Copied article.txt to shared directory. " name) 
                          sleep(15)
                          sys2var(command)
                        }
                        else {
                          sendto("ia9out-manual", name, "articletxtmissing")
                          abort("demon-lin.awk: Error article.txt.final missing. Sent to manual. " name)
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        }
      } 
      else {
        abort("demon-lin.awk: error retrieving name")
      }  
      prnt("\ndemon-lin.awk: Waiting for " Ramdisk "name.txt ...")
    }
  }
}

#
# Return the path/tempid of a name (eg. /home/adminuser/wi-awb/temp/wi-awb-0202173111/)
#
function whatistempid(name, filen,    filepath, s, a, re) {
  filepath = Home filen
  if(! exists(filepath) ) {
    abort("demon-lin.awk: Error unable to find " filepath ". " name )
    return 0
  }
  re = "^" name "$"
  while ((getline s < filepath ) > 0) {
    split(s, a, "|")
    if(strip(a[1]) ~ re)
      return strip(a[2])
  }
  close(filepath)
  return 0
}

#
# Return 1 if name is in file 
#
function nameisinfile(name, filen,    filepath, s, a, re) {
  filepath = Home filen
  if(! exists(filepath) ) {
    abort("demon-lin.awk: Error unable to find " filepath ". " name )
    return 0
  }
  re = "^" name "$"
  while ((getline s < filepath ) > 0) {
    split(s, a, "|")
    if(strip(a[1]) ~ re)
      return 1
  }
  close(filepath)
  return 0
}

#
# Return 1 if name has a z entry in extasciiwildfix.0001-0906.tc.cfg
#
function nameisaz(name,   filepath, s, a, b, re) {
  filepath = Home "extasciiwildfix.0001-0906.tc.cfg"
  if(! exists(filepath) ) {
    abort("demon-lin.awk: Error unable to find " filepath ". " name)
    return 0
  }
  re = "^" name "$"
  while ((getline s < filepath ) > 0) {
    c = split(s, a, "|")
    if(c == 3 && strip(a[1]) ~ re && strip(a[2]) ~ /z/) 
      return 1
  }
  close(filepath)
  return 0
}

#
# Abort 
#
function abort(msg,  filen) {
  if( length(msg) > 0 ) 
    prnt(msg)
  printf "0" > Ramdisk "abort.txt"
  close(Ramdisk "abort.txt")
}

#
# Print and log messages
#
function prnt(msg) {
  if( length(msg) > 0 ) {
    print(msg)
    print(strftime("%Y%m%d %H:%M:%S") " " msg) >> Home "demon-lin.log"
    close(Home "demon-lin.log")
  }
}

#
# Write to a database
#   eg. sendto("ia9out-manual", name, "choosetxt")
#
function sendto(database, name, msg,     command) {
  command = AWK " -v indexf=\"" Home database "\" -v name=\"" name  "\" -v stamp=\"" msg "\" -f " Home "index.awk"
  if( sys2var(command) != 1) {
    prnt("demon-lin.awk: Error unable to write to database using command: " command ". " name )
  }

}

function removefile(str) {
      if( exists(str) )
        sys2var(RM " -- " str)
      if( exists(str) ) {
        abort("demon-lin.awk: Error unable to delete " str ", aborting.")
        exit
      }
      system("") # Flush buffer
}

#
# http2var - replicate "wget -q -O- http://..." in pure gawk
#   Return the HTML page as a string.
#
function http2var(url)
{
     return sys2var( WGET " -q -O- \"" url "\"") 
}

#
# Sleep 
#
function sleep(seconds)
{
  sys2var( SLEEP " " seconds)
}


